<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
   
   <meta name="description" content="FLUBIO - An unstructured, parallel, finite volume Navier-Stokes solver for teaching and research purposes">
    
    <meta name="author" content="Edoardo Alinovi and Joel Guerrero" >
    <link rel="icon" href="../favicon.png">

    <title>chomp &ndash; FLUBIO</title>

    <link href="../css/bootstrap.min.css" rel="stylesheet">
    <link href="../css/pygments.css" rel="stylesheet">
    <link href="../css/font-awesome.min.css" rel="stylesheet">
    <link href="../css/local.css" rel="stylesheet">
    
    <link  href="../tipuesearch/tipuesearch.css" rel="stylesheet">
    
    

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
    
    <script src="../js/jquery-2.1.3.min.js"></script>
    <script src="../js/svg-pan-zoom.min.js"></script>

  </head>

  <body>

    <!-- Fixed navbar -->
    <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="../index.html">FLUBIO </a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <ul class="nav navbar-nav">
        
            <li class="dropdown hidden-xs visible-sm visible-md hidden-lg">
              <a href="#" class="dropdown-toggle"
              data-toggle="dropdown" role="button"
              aria-haspopup="true"
     aria-expanded="false">Contents <span class="caret"></span></a>
        <ul class="dropdown-menu">
          
              
            <li><a href="../lists/files.html">Source Files</a></li>
        
        
        
            <li><a href="../lists/modules.html">Modules</a></li>
        
            
                                
            <li><a href="../lists/procedures.html">Procedures</a></li>
        
               
            <li><a href="../lists/types.html">Derived Types</a></li>
        
        
            <li><a href="../lists/programs.html">Programs</a></li>
               
        
        
            </ul>
        
            </li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/files.html">Source Files</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/modules.html">Modules</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/procedures.html">Procedures</a></li>

                             
<li class="visible-xs hidden-sm visible-lg"><a href="../lists/types.html">Derived Types</a></li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/programs.html">Programs</a></li>



          </ul>
        
        <form action="../search.html" class="navbar-form navbar-right" role="search">
        <div class="form-group">
          <input type="text" class="form-control" placeholder="Search" name="q" id="tipue_search_input" autocomplete="off" required>
        </div>
<!--
        <button type="submit" class="btn btn-default">Submit</button>
-->
        </form>
        
        </div><!--/.nav-collapse -->
      </div>
    </nav>

    <div class="container">
    
  
  <div class="row">
    <h1>chomp
      <small>Function</small>
    
    </h1>
    
<div class="row">
  <div class="col-lg-12">
<div class="well well-sm">
  <ul class="list-inline" style="margin-bottom:0px;display:inline">
     
     
     
    <li><i class="fa fa-legal"></i> <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a></li> 
     
     
     
    
    
     <li><i class="fa fa-list-ol"></i>
       <a data-toggle="tooltip"
    data-placement="bottom" data-html="true"
    title=" 0.2% of total for procedures.">40 statements</a>
     </li> 
     
     
     
    <li><i class="fa fa-code"></i><a href="../src/mstrings.f03"> Source File</a></li>
     
     
  </ul>
  <ol class="breadcrumb in-well text-right">
  
    
     <li><a href='../sourcefile/mstrings.f03.html'>mstrings.f03</a></li>
    
     <li><a href='../module/m_strings.html'>M_strings</a></li>
    
  
     <li class="active">chomp</li>
  </ol>
</div>
</div>
</div>
<script>
  $(function () {
  $('[data-toggle="tooltip"]').tooltip()
  })
</script>

  </div>
  
  <div class="row">
    <div class="col-md-3 hidden-xs hidden-sm visible-md visible-lg">
    
<div id="sidebar">
  
<h3>Contents</h3>
 





















<em>None</em>


</div>

    </div>
    
    <div class="col-md-9" id='text'>
    <h2>
public function chomp(source_string, token, delimiters)
    
    
   
</h2>
    
  


    
    <h2>NAME</h2>
<div class="codehilite"><pre><span></span><code>chomp(3f) - [M_strings:TOKENS] Tokenize a string, consuming it one token per call
</code></pre></div>

<h2>SYNOPSIS</h2>
<div class="codehilite"><pre><span></span><code><span class="k">function</span><span class="w"> </span><span class="nf">chomp</span><span class="p">(</span>source_string,token[,delimiters]<span class="p">)</span><span class="w"></span>

<span class="w"> </span><span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="p">=</span><span class="o">*</span><span class="p">)</span><span class="w">                     </span><span class="p">::</span><span class="w"> </span><span class="n">source_string</span><span class="w"></span>
<span class="w"> </span><span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="p">=:),</span><span class="n">intent</span><span class="p">(</span><span class="n">out</span><span class="p">),</span><span class="n">token</span><span class="w">   </span><span class="p">::</span><span class="w"> </span><span class="n">token</span><span class="w"></span>
<span class="w"> </span><span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="p">=:),</span><span class="n">intent</span><span class="p">(</span><span class="n">in</span><span class="p">),</span><span class="n">optional</span><span class="w"> </span><span class="p">::</span><span class="w"> </span><span class="n">delimiters</span><span class="w"></span>
<span class="w"> </span><span class="n">integer</span><span class="w">                              </span><span class="p">::</span><span class="w"> </span><span class="n">chomp</span><span class="w"></span>
</code></pre></div>

<h2>DESCRIPTION</h2>
<div class="codehilite"><pre><span></span><code><span class="nv">The</span> <span class="nv">CHOMP</span><span class="ss">(</span><span class="mi">3</span><span class="nv">f</span><span class="ss">)</span> <span class="nv">function</span> <span class="nv">is</span> <span class="nv">used</span> <span class="nv">to</span> <span class="nv">isolate</span> <span class="nv">sequential</span> <span class="nv">tokens</span> <span class="nv">in</span> <span class="nv">a</span>
<span class="nv">string</span>, <span class="nv">SOURCE_STRING</span>. <span class="nv">These</span> <span class="nv">tokens</span> <span class="nv">are</span> <span class="nv">delimited</span> <span class="nv">in</span> <span class="nv">the</span> <span class="nv">string</span> <span class="nv">by</span> <span class="nv">at</span>
<span class="nv">least</span> <span class="nv">one</span> <span class="nv">of</span> <span class="nv">the</span> <span class="nv">characters</span> <span class="nv">in</span> <span class="nv">DELIMITERS</span>. <span class="nv">This</span> <span class="nv">routine</span> <span class="nv">consumes</span> <span class="nv">the</span>
<span class="nv">source_string</span> <span class="nv">one</span> <span class="nv">token</span> <span class="nv">per</span> <span class="nv">call</span>. <span class="nv">It</span> <span class="nv">returns</span> <span class="o">-</span><span class="mi">1</span> <span class="nv">when</span> <span class="nv">complete</span>. <span class="nv">The</span>
<span class="nv">default</span> <span class="nv">delimiter</span> <span class="nv">list</span> <span class="nv">is</span> <span class="s2">&quot;</span><span class="s">space,tab,carriage return,newline</span><span class="s2">&quot;</span>.
</code></pre></div>

<h2>OPTIONS</h2>
<div class="codehilite"><pre><span></span><code> SOURCE_STRING  string to tokenize
 DELIMITERS     list of separator characters
</code></pre></div>

<h2>RETURNS</h2>
<div class="codehilite"><pre><span></span><code> TOKEN          returned token
 CHOMP          status flag. 0 = success, -1 = no tokens remain
</code></pre></div>

<h2>EXAMPLES</h2>
<p>Sample program:</p>
<div class="codehilite"><pre><span></span><code><span class="n">program</span><span class="w"> </span><span class="n">demo_chomp</span><span class="w"></span>

<span class="k">use</span><span class="w"> </span><span class="n">M_strings</span><span class="p">,</span><span class="w"> </span><span class="k">only</span><span class="w"> </span><span class="err">:</span><span class="w"> </span><span class="n">chomp</span><span class="w"></span>
<span class="n">implicit</span><span class="w"> </span><span class="k">none</span><span class="w"></span>
<span class="k">character</span><span class="p">(</span><span class="nf">len</span><span class="o">=</span><span class="mi">100</span><span class="p">)</span><span class="w">            </span><span class="o">::</span><span class="w"> </span><span class="n">inline</span><span class="w"></span>
<span class="k">character</span><span class="p">(</span><span class="nf">len</span><span class="o">=</span><span class="err">:</span><span class="p">),</span><span class="n">allocatable</span><span class="w">  </span><span class="o">::</span><span class="w"> </span><span class="n">token</span><span class="w"></span>
<span class="k">character</span><span class="p">(</span><span class="nf">len</span><span class="o">=*</span><span class="p">),</span><span class="k">parameter</span><span class="w">    </span><span class="o">::</span><span class="w"> </span><span class="n">delimiters</span><span class="o">=</span><span class="s1">&#39; ;,&#39;</span><span class="w"></span>
<span class="k">integer</span><span class="w">                       </span><span class="o">::</span><span class="w"> </span><span class="n">ios</span><span class="w"></span>
<span class="k">integer</span><span class="w">                       </span><span class="o">::</span><span class="w"> </span><span class="n">icount</span><span class="w"></span>
<span class="k">integer</span><span class="w">                       </span><span class="o">::</span><span class="w"> </span><span class="n">itoken</span><span class="w"></span>
<span class="w">   </span><span class="n">icount</span><span class="o">=</span><span class="mi">0</span><span class="w"></span>
<span class="w">   </span><span class="n">do</span><span class="w">        </span><span class="err">!</span><span class="w"> </span><span class="k">read</span><span class="w"> </span><span class="n">lines</span><span class="w"> </span><span class="k">from</span><span class="w"> </span><span class="n">stdin</span><span class="w"> </span><span class="n">until</span><span class="w"> </span><span class="k">end</span><span class="o">-</span><span class="k">of</span><span class="o">-</span><span class="k">file</span><span class="w"> </span><span class="ow">or</span><span class="w"> </span><span class="n">error</span><span class="w"></span>
<span class="w">      </span><span class="k">read</span><span class="w"> </span><span class="p">(</span><span class="n">unit</span><span class="o">=*</span><span class="p">,</span><span class="n">fmt</span><span class="o">=</span><span class="ss">&quot;(a)&quot;</span><span class="p">,</span><span class="n">iostat</span><span class="o">=</span><span class="n">ios</span><span class="p">)</span><span class="w"> </span><span class="n">inline</span><span class="w"></span>
<span class="w">      </span><span class="k">if</span><span class="p">(</span><span class="n">ios</span><span class="p">.</span><span class="n">ne</span><span class="mf">.0</span><span class="p">)</span><span class="n">stop</span><span class="w"></span>
<span class="w">      </span><span class="n">icount</span><span class="o">=</span><span class="n">icount</span><span class="o">+</span><span class="mi">1</span><span class="w"></span>
<span class="w">      </span><span class="n">itoken</span><span class="o">=</span><span class="mi">0</span><span class="w"></span>
<span class="w">      </span><span class="k">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="o">*</span><span class="p">)</span><span class="s1">&#39;INLINE &#39;</span><span class="p">,</span><span class="k">trim</span><span class="p">(</span><span class="n">inline</span><span class="p">)</span><span class="w"></span>
<span class="w">      </span><span class="n">do</span><span class="w"> </span><span class="k">while</span><span class="w"> </span><span class="p">(</span><span class="w"> </span><span class="n">chomp</span><span class="p">(</span><span class="n">inline</span><span class="p">,</span><span class="n">token</span><span class="p">,</span><span class="n">delimiters</span><span class="p">).</span><span class="n">ge</span><span class="p">.</span><span class="w"> </span><span class="mi">0</span><span class="p">)</span><span class="w"></span>
<span class="w">         </span><span class="n">itoken</span><span class="o">=</span><span class="n">itoken</span><span class="o">+</span><span class="mi">1</span><span class="w"></span>
<span class="w">         </span><span class="k">print</span><span class="w"> </span><span class="o">*</span><span class="p">,</span><span class="w"> </span><span class="n">itoken</span><span class="p">,</span><span class="s1">&#39;TOKEN=[&#39;</span><span class="o">//</span><span class="k">trim</span><span class="p">(</span><span class="n">token</span><span class="p">)</span><span class="o">//</span><span class="s1">&#39;]&#39;</span><span class="w"></span>
<span class="w">      </span><span class="n">enddo</span><span class="w"></span>
<span class="w">   </span><span class="n">enddo</span><span class="w"></span>

<span class="k">end</span><span class="w"> </span><span class="n">program</span><span class="w"> </span><span class="n">demo_chomp</span><span class="w"></span>

<span class="n">sample</span><span class="w"> </span><span class="k">input</span><span class="w"> </span><span class="k">file</span><span class="w"></span>

<span class="w"> </span><span class="n">this</span><span class="w"> </span><span class="k">is</span><span class="w"> </span><span class="n">a</span><span class="w"> </span><span class="n">test</span><span class="w"> </span><span class="k">of</span><span class="w"> </span><span class="n">chomp</span><span class="p">;</span><span class="w"> </span><span class="nl">A</span><span class="p">:</span><span class="n">B</span><span class="w"> </span><span class="err">:</span><span class="p">;,</span><span class="n">C</span><span class="p">;;</span><span class="w"></span>

<span class="n">sample</span><span class="w"> </span><span class="k">output</span><span class="w"> </span><span class="k">file</span><span class="w"></span>

<span class="w"> </span><span class="n">INLINE</span><span class="w">     </span><span class="n">this</span><span class="w"> </span><span class="k">is</span><span class="w"> </span><span class="n">a</span><span class="w"> </span><span class="n">test</span><span class="w"> </span><span class="k">of</span><span class="w"> </span><span class="n">chomp</span><span class="p">;</span><span class="w"> </span><span class="nl">A</span><span class="p">:</span><span class="n">B</span><span class="w"> </span><span class="err">:</span><span class="p">;,</span><span class="n">C</span><span class="p">;;</span><span class="w"></span>
<span class="w">           </span><span class="mi">1</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">this</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">2</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">is</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">3</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">a</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">4</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">test</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">5</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">of</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">6</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">chomp</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">7</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">A:B</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">8</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">:</span><span class="o">]</span><span class="w"></span>
<span class="w">           </span><span class="mi">9</span><span class="w"> </span><span class="n">TOKEN</span><span class="o">=[</span><span class="n">C</span><span class="o">]</span><span class="w"></span>
</code></pre></div>
    

    <h3>Arguments</h3>
    
      
<table class="table table-striped varlist">
<thead><tr><th>Type</th>
<th>Intent</th><th>Optional</th>
<th>Attributes</th><th></th><th>Name</th><th></th></thead>



<tbody>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-source_string"></span>character(len=*)</td>
  <td></td>
  <td></td>
  
  <td></td><td>::</td>
  <td><strong>source_string</strong></td><td></td>
  
</tr>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-token"></span>character(len=:),</td>
  <td>intent(out),</td>
  <td></td>
  
  <td>allocatable</td><td>::</td>
  <td><strong>token</strong></td><td></td>
  
</tr>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-delimiters"></span>character(len=*),</td>
  <td>intent(in),</td>
  <td>optional</td>
  
  <td></td><td>::</td>
  <td><strong>delimiters</strong></td><td></td>
  
</tr>

</tbody>
</table>

    
    
    
    
    
    
    
   <h3>Return Value <small><span class="anchor" id="variable-chomp"></span>integer
  </small></h3>
    
    
    
    
     
    <br>

    <section class="visible-xs visible-sm hidden-md">
      
<h3>Contents</h3>
 





















<em>None</em>


    </section>
    <br class="visible-xs visible-sm hidden-md">

    

    
    
    
    
    

    
    
    
    
    


    
    
    
    
    </div>
  </div>


    <hr>    
    </div> <!-- /container -->
    <footer>
      <div class="container">
      <div class="row">
        <div class="col-xs-6 col-md-6"><p>FLUBIO was developed by Edoardo Alinovi and Joel Guerrero<br>&copy; 2021 <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a>
                                          </p>
        </div>
        <div class="col-xs-6 col-md-6">
          <p class="text-right">
            Documentation generated by 
            <a href="https://github.com/Fortran-FOSS-Programmers/ford">FORD</a>
            
            
          </p>
        </div>
      </div>
      <br>
      </div> <!-- /container -->    
    </footer>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
<!--
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
-->
    <script src="../js/bootstrap.min.js"></script>
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <script src="../js/ie10-viewport-bug-workaround.js"></script>

    <!-- MathJax JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script type="text/x-mathjax-config">
      MathJax.Hub.Config({
        TeX: { extensions: ['AMSmath.js','AMSsymbols.js','noErrors.js','noUndefined.js'], equationNumbers: { autoNumber: 'AMS' } },
        jax: ['input/TeX','input/MathML','output/HTML-CSS'],
        extensions: ['tex2jax.js','mml2jax.js','MathMenu.js','MathZoom.js']
      });
    </script>
    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    
    <script src="../tipuesearch/tipuesearch_content.js"></script>
    <script src="../tipuesearch/tipuesearch_set.js"></script>
    <script src="../tipuesearch/tipuesearch.js"></script>
    
    
  </body>
</html>